package com.gree.mall.manager.bean.worker;

import com.gree.mall.manager.annotation.ZfireField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.data.elasticsearch.annotations.Field;
import org.springframework.data.elasticsearch.annotations.FieldType;
import org.springframework.stereotype.Service;

import javax.validation.constraints.NotBlank;
import java.math.BigDecimal;
import java.util.Date;

@ApiModel
@Data
public class SettlementPgOrderVO {

    @ZfireField(tbName = "d")
    @ApiModelProperty(value = "所属公司")
    private String belongCompany;
    @ZfireField(tbName = "d")
    @ApiModelProperty(value = "所属公司编号")
    private String belongCompanyCode;

    @ZfireField(tbName = "d")
    @ApiModelProperty(value = "网点编号")
    private String websitId;
    @ZfireField(tbName = "d",colName = "name")
    @ApiModelProperty(value = "网点名称")
    private String websitName;
    @ZfireField(tbName = "d")
    @ApiModelProperty(value = "网点联系人")
    private String linkName;
    @ZfireField(tbName = "d")
    @ApiModelProperty(value = "网点联系人电话")
    private String linkMobile;
    @ZfireField(tbName = "a",colName = "worker_number")
    @ApiModelProperty("师傅编号")
    private String workerNumber;
    @ZfireField(tbName = "a",colName = "worker_name")
    @ApiModelProperty("师傅名称")
    private String workerName;
    @ZfireField(tbName = "a",colName = "worker_mobile")
    @ApiModelProperty(value = "师傅电话")
    private String workerMobile;
    @ZfireField(tbName = "b",colName = "worker_mobile")
    @ApiModelProperty(value = "工单类型")
    private String orderSmallTypeText;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "总工单数（单）")
    private Integer zgds;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "设备总台数（台）")
    private Integer sbzts;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "电子支付工单数量（单）")
    private Integer dzzfs=0;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "电子支付设备总台数（台）")
    private Integer dzzfsbts=0;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "电子支付总金额（元）")
    private BigDecimal dzzfzje=BigDecimal.ZERO;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "电子支付平均费用（元/台）")
    private BigDecimal dzzfpjfy=BigDecimal.ZERO;

    @ZfireField(isQuery = false)
    @ApiModelProperty(value = "电子支付总平均费用（元/台）")
    private BigDecimal dzzfzpjfy=BigDecimal.ZERO;
}
